import java.util.EmptyStackException;
import java.util.Stack;

class UPN {

	public static void main(String[] args) {
		Stack<Hexa> stapel = new Stack<Hexa>();
		while (true) {
			String eingabe = IO.readString("Eingabe: ");
			try {
				if (eingabe.equals("q")) {
					break;
				} else if (eingabe.equals("+")) {
					Hexa summand2 = (Hexa) stapel.pop();
					Hexa summand1 = (Hexa) stapel.pop();
					Hexa summe = Hexa.addiere(summand1, summand2);
					IO.println(summe.toString());
					stapel.push(summe);
				} else if (eingabe.equals("-")) {
					try {
						Hexa was = (Hexa) stapel.pop();
						Hexa von = (Hexa) stapel.pop();
						Hexa diff = Hexa.subtrahiere(von, was);
						IO.println(diff.toString());
						stapel.push(diff);
					} catch (InvalidHexaException obj) {
						IO.println(obj.toString());
						break;
					}
				} else if (eingabe.equals("*")) {
					Hexa fak2 = (Hexa) stapel.pop();
					Hexa fak1 = (Hexa) stapel.pop();
					Hexa prod = Hexa.multipliziere(fak1, fak2);
					IO.println(prod.toString());
					stapel.push(prod);
				} else if (eingabe.equals("/")) {
					try {
						Hexa div = (Hexa) stapel.pop();
						Hexa durch = (Hexa) stapel.pop();
						Hexa quo = Hexa.dividiere(div, durch);
						IO.println(quo.toString());
						stapel.push(quo);
					} catch (DivNullException obj) {
						IO.println("Fehler: Divison durch 0!");
						break;
					}
				} else if (eingabe.equals("%")) {
					try {
						Hexa div = stapel.pop();
						Hexa durch = stapel.pop();
						Hexa rest = Hexa.modulo(div, durch);
						IO.println(rest.toString());
						stapel.push(rest);
					} catch (DivNullException obj) {
						IO.println("Fehler: Divison durch 0!");
						break;
					}
				} else {
					try {
						Hexa hexa = new Hexa(eingabe);
						stapel.push(hexa);
					} catch (InvalidHexaException obj) {
						IO.println(obj.toString());
					}
				}
			} catch (EmptyStackException obj) {
				IO.println("Fehler: leerer Stack!");
				break;
			}
		}
	}
}

public class UE21Aufgabe9 {
	public static void main(String[] args) {
		
	}
}
