package bus30;

public class Busnetz {

	// initialisiert ein Busnetz
	public Busnetz() {
	}

	// liefert Informationen zur Verbindung der Haltestellen "von" nach
	// "nach";
	// in den Elementen des gelieferten Arrays stehen in der
	// entsprechenden Reihenfolge die nacheinander angefahrenen
	// Haltestellen
	// die Exception wird geworfen, wenn keine Verbindung existiert
	public Haltestelle[] getVerbindung(Haltestelle von, Haltestelle nach) throws KeineVerbindungException {
		// nur zum Testen
		if (von.getName().equals("Badesee")) {
			throw new KeineVerbindungException();
		}
		try {
			Haltestelle[] hs = new Haltestelle[5];
			hs[0] = Haltestelle.getHaltestelle("Hauptbahnhof");
			hs[1] = Haltestelle.getHaltestelle("Freibad");
			hs[2] = Haltestelle.getHaltestelle("Turnhalle");
			hs[3] = Haltestelle.getHaltestelle("Friedhof");
			hs[4] = Haltestelle.getHaltestelle("Schule");
			return hs;
		} catch (UnbekannteHaltestelleException exc) {
			throw new KeineVerbindungException();
		}
	}
}
