class Util {

	// liefert die kleinste Zahl des uebergebenen Arrays
	public static int minimum(int[] werte) {
		int min = werte[0];
		for (int i = 1; i < werte.length; i++) {
			if (werte[i] < min) {
				min = werte[i];
			}
		}
		return min;
	}

	// konvertiert den uebergebenen String in einen int-Wert
	public static int toInt(String str) {
		int erg = 0, faktor = 1;
		char ch = str.charAt(0);
		switch (ch) {
		case '-':
			faktor = -1;
			break;
		case '+':
			faktor = 1;
			break;
		default:
			erg = ch - '0';
		}
		for (int i = 1; i < str.length(); i++) {
			ch = str.charAt(i);
			int ziffer = ch - '0';
			erg = erg * 10 + ziffer;
		}
		return faktor * erg;
	}

	// liefert die Potenz von zahl mit exp, also zahl "hoch" exp
	public static long hoch(long zahl, int exp) {
		if (exp == 0) {
			return 1L;
		}
		return zahl * Util.hoch(zahl, exp - 1);
	}
}

public class UE21Aufgabe17 {

	// Testprogramm
	public static void main(String[] args) {
		String eingabe = IO.readString("Zahl: ");
		int zahl = Util.toInt(eingabe);
		System.out.println(zahl + " hoch " + zahl + " = "
				+ Util.hoch(zahl, zahl));
	}
}

